'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var addModifierClass = function addModifierClass(modifier, modValue) {
  return function (classname) {
    return (0, _classnames2.default)(classname, _defineProperty({}, classname + '--' + modifier, modValue));
  };
};

var AccordionSelect = function AccordionSelect(_ref) {
  var selected = _ref.selected,
      opened = _ref.opened,
      infoText = _ref.infoText,
      children = _ref.children,
      onClick = _ref.onClick,
      disabled = _ref.disabled,
      dataTest = _ref.dataTest;

  var addClassWithSelected = addModifierClass('selected', selected);
  var addClassWithOpened = addModifierClass('opened', opened);
  var addClassWithDisabled = addModifierClass('disabled', disabled);

  return _react2.default.createElement(
    'li',
    { className: addClassWithSelected('wide-button') + ' wide-button--accordion ' + addClassWithDisabled('wide-button'), 'data-test': dataTest },
    _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)('wide-button__title--space-between', addClassWithSelected('wide-button__title')) },
      children
    ),
    _react2.default.createElement(
      'div',
      {
        className: addClassWithOpened('wide-button__content') + ' ' + addClassWithSelected('wide-button__tooltip-text'),
        onClick: onClick
      },
      infoText && _react2.default.createElement(
        'p',
        { className: 'wide-button__tooltip-text' },
        infoText
      )
    )
  );
};

AccordionSelect.propTypes = {
  selected: _propTypes2.default.bool,
  opened: _propTypes2.default.bool,
  infoText: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  children: _propTypes2.default.any,
  disabled: _propTypes2.default.bool,
  dataTest: _propTypes2.default.string
};

exports.default = AccordionSelect;