'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ButtonsListSelectOptions = require('./ButtonsListSelectOptions');

var _ButtonsListSelectOptions2 = _interopRequireDefault(_ButtonsListSelectOptions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ButtonsListSelect = function (_Component) {
  _inherits(ButtonsListSelect, _Component);

  function ButtonsListSelect(props) {
    _classCallCheck(this, ButtonsListSelect);

    var _this = _possibleConstructorReturn(this, (ButtonsListSelect.__proto__ || Object.getPrototypeOf(ButtonsListSelect)).call(this, props));

    _initialiseProps.call(_this);

    var itemsToShow = props.isViewMoreEnabled ? props.itemsToShowFirstRender : props.options.length;

    _this.state = {
      itemsToShow: itemsToShow,
      isViewMoreRendered: props.isViewMoreEnabled
    };
    return _this;
  }

  _createClass(ButtonsListSelect, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          onOpenHelp = _props.onOpenHelp,
          onCloseHelp = _props.onCloseHelp,
          selectedOptions = _props.selectedOptions,
          accordion = _props.accordion,
          errorMessage = _props.errorMessage,
          viewMoreButtonText = _props.viewMoreButtonText,
          showCheckbox = _props.showCheckbox,
          dataTest = _props.dataTest,
          tooltipLOB = _props.tooltipLOB;
      var _state = this.state,
          isViewMoreRendered = _state.isViewMoreRendered,
          itemsToShow = _state.itemsToShow;

      var optionsToRender = this.getOptionsToRender(itemsToShow, isViewMoreRendered);

      return _react2.default.createElement(
        'div',
        null,
        errorMessage && _react2.default.createElement(
          'p',
          { className: 'error-message' },
          errorMessage
        ),
        _react2.default.createElement(_ButtonsListSelectOptions2.default, {
          options: optionsToRender,
          selectedOptions: selectedOptions,
          onClick: this.handleClick,
          onOpenHelp: onOpenHelp,
          onCloseHelp: onCloseHelp,
          opened: tooltipLOB,
          accordion: accordion,
          showCheckbox: showCheckbox,
          dataTest: dataTest
        }),
        isViewMoreRendered && _react2.default.createElement(
          'button',
          { className: 'button-view-more', onClick: this.viewMoreClicked },
          viewMoreButtonText || 'View more',
          _react2.default.createElement('span', { className: 'button-view-more__arrow fa fa-angle-down' })
        )
      );
    }
  }]);

  return ButtonsListSelect;
}(_react.Component);

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.getOptionsToRender = function (itemsToShow, isViewMoreRendered) {
    var options = _this2.props.options;

    return isViewMoreRendered ? options.slice(0, itemsToShow) : options;
  };

  this.calculateItemsToShow = function () {
    var itemsToShow = _this2.state.itemsToShow;
    var _props2 = _this2.props,
        itemsPerPage = _props2.itemsPerPage,
        options = _props2.options,
        isViewMoreEnabled = _props2.isViewMoreEnabled;

    var result = void 0;

    if (isViewMoreEnabled) {
      var nextPageMaxIndex = itemsToShow + itemsPerPage;

      result = Math.min(nextPageMaxIndex, options.length);
    }

    return result;
  };

  this.areOptionsLeft = function (itemsToShow) {
    if (!_this2.state.isViewMoreRendered) {
      return false;
    }

    return itemsToShow < _this2.props.options.length;
  };

  this.handleClick = function (value) {
    var _props3 = _this2.props,
        selectedOptions = _props3.selectedOptions,
        onSelect = _props3.onSelect,
        onDeselect = _props3.onDeselect;


    if (selectedOptions.includes(value)) {
      onDeselect(value);
    } else {
      onSelect(value);
    }
  };

  this.renderNextItems = function () {
    _this2.setState(function () {
      var itemsToShow = _this2.calculateItemsToShow();
      var isViewMoreRendered = _this2.areOptionsLeft(itemsToShow);

      return {
        itemsToShow: itemsToShow,
        isViewMoreRendered: isViewMoreRendered
      };
    });
  };

  this.viewMoreClicked = function () {
    var onViewMoreClick = _this2.props.onViewMoreClick;


    _this2.renderNextItems();

    if (onViewMoreClick) {
      onViewMoreClick();
    }
  };
};

ButtonsListSelect.propTypes = {
  options: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
  selectedOptions: _propTypes2.default.arrayOf(_propTypes2.default.string),
  onSelect: _propTypes2.default.func.isRequired,
  onDeselect: _propTypes2.default.func.isRequired,
  onOpenHelp: _propTypes2.default.func,
  onCloseHelp: _propTypes2.default.func,
  onViewMoreClick: _propTypes2.default.func,
  isViewMoreEnabled: _propTypes2.default.bool,
  itemsToShowFirstRender: _propTypes2.default.number,
  itemsPerPage: _propTypes2.default.number,
  accordion: _propTypes2.default.bool,
  showCheckbox: _propTypes2.default.bool,
  errorMessage: _propTypes2.default.string,
  viewMoreButtonText: _propTypes2.default.string,
  dataTest: _propTypes2.default.string,
  tooltipLOB: _propTypes2.default.bool
};

ButtonsListSelect.defaultProps = {
  itemsToShowFirstRender: 6,
  itemsPerPage: 12,
  options: [],
  selectedOptions: [],
  isViewMoreEnabled: true,
  showCheckbox: false,
  dataTest: '',
  tooltipLOB: false
};

exports.default = ButtonsListSelect;