'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _AccordionSelect = require('./AccordionSelect');

var _AccordionSelect2 = _interopRequireDefault(_AccordionSelect);

var _WideButton = require('./WideButton');

var _WideButton2 = _interopRequireDefault(_WideButton);

var _QuestionIcon = require('./QuestionIcon');

var _QuestionIcon2 = _interopRequireDefault(_QuestionIcon);

var _CheckboxIcon = require('./CheckboxIcon');

var _CheckboxIcon2 = _interopRequireDefault(_CheckboxIcon);

var _TextWithIcon = require('./TextWithIcon');

var _TextWithIcon2 = _interopRequireDefault(_TextWithIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ButtonsListSelectOption = function (_Component) {
  _inherits(ButtonsListSelectOption, _Component);

  function ButtonsListSelectOption(props) {
    _classCallCheck(this, ButtonsListSelectOption);

    var _this = _possibleConstructorReturn(this, (ButtonsListSelectOption.__proto__ || Object.getPrototypeOf(ButtonsListSelectOption)).call(this, props));

    _this.onClickTitle = function () {
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          value = _this$props.value,
          disabled = _this$props.disabled;


      if (disabled) return;

      onClick(value);
    };

    _this.onClickTooltip = function () {
      var opened = _this.state.opened;
      var _this$props2 = _this.props,
          onOpenHelp = _this$props2.onOpenHelp,
          onCloseHelp = _this$props2.onCloseHelp,
          value = _this$props2.value;


      _this.setState({ opened: !opened });

      if (!opened && onOpenHelp) {
        onOpenHelp(value, '?');
      } else if (opened && onCloseHelp) {
        onCloseHelp(value, '?');
      }
    };

    _this.state = {
      opened: props.opened
    };
    return _this;
  }

  _createClass(ButtonsListSelectOption, [{
    key: 'renderAccordion',
    value: function renderAccordion() {
      var _props = this.props,
          label = _props.label,
          iconClass = _props.iconClass,
          infoText = _props.infoText,
          selected = _props.selected,
          showCheckbox = _props.showCheckbox,
          disabled = _props.disabled,
          dataTest = _props.dataTest;
      var opened = this.state.opened;


      return _react2.default.createElement(
        _AccordionSelect2.default,
        { infoText: infoText, opened: opened, selected: selected, onClick: this.onClickTitle, disabled: disabled, dataTest: dataTest },
        _react2.default.createElement(
          'div',
          { onClick: this.onClickTitle, className: 'wide-button__title-container' },
          showCheckbox && _react2.default.createElement(_CheckboxIcon2.default, { checked: selected }),
          _react2.default.createElement(_TextWithIcon2.default, { className: 'wide-button__title-item', label: label, iconClass: iconClass })
        ),
        infoText && _react2.default.createElement(
          'div',
          { className: 'wide-button__right-button', onClick: this.onClickTooltip },
          _react2.default.createElement(_QuestionIcon2.default, { accordion: true, type: selected ? 'colored-inverted' : 'colored' })
        )
      );
    }
  }, {
    key: 'renderWideButton',
    value: function renderWideButton() {
      var _props2 = this.props,
          label = _props2.label,
          iconClass = _props2.iconClass,
          infoText = _props2.infoText,
          selected = _props2.selected,
          dataTest = _props2.dataTest;


      return _react2.default.createElement(
        _WideButton2.default,
        { selected: selected, dataTest: dataTest },
        _react2.default.createElement(_TextWithIcon2.default, { className: 'wide-button__title-item', label: label, iconClass: iconClass, onClick: this.onClickTitle }),
        _react2.default.createElement(
          'div',
          { className: 'wide-button__right-button question-icon__tooltip' },
          _react2.default.createElement(_QuestionIcon2.default, { infoText: infoText, type: selected ? 'colored-inverted' : 'colored' })
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var accordion = this.props.accordion;


      return accordion ? this.renderAccordion() : this.renderWideButton();
    }
  }]);

  return ButtonsListSelectOption;
}(_react.Component);

ButtonsListSelectOption.propTypes = {
  value: _propTypes2.default.string.isRequired,
  label: _propTypes2.default.string.isRequired,
  infoText: _propTypes2.default.string,
  selected: _propTypes2.default.bool,
  opened: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  accordion: _propTypes2.default.bool,
  showCheckbox: _propTypes2.default.bool,
  iconClass: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  onOpenHelp: _propTypes2.default.func,
  onCloseHelp: _propTypes2.default.func,
  iconToolTip: _propTypes2.default.func,
  dataTest: _propTypes2.default.string
};

exports.default = ButtonsListSelectOption;