'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ButtonsListSelectOption = require('./ButtonsListSelectOption');

var _ButtonsListSelectOption2 = _interopRequireDefault(_ButtonsListSelectOption);

var _dataTestHelper = require('../utils/dataTestHelper');

var _dataTestHelper2 = _interopRequireDefault(_dataTestHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ButtonsListSelectOptions = function ButtonsListSelectOptions(props) {
  var options = props.options,
      selectedOptions = props.selectedOptions,
      onClick = props.onClick,
      onOpenHelp = props.onOpenHelp,
      onCloseHelp = props.onCloseHelp,
      accordion = props.accordion,
      showCheckbox = props.showCheckbox,
      dataTest = props.dataTest,
      opened = props.opened;


  return _react2.default.createElement(
    'ul',
    { className: 'buttons-list-select-options' },
    options.map(function (option) {
      return _react2.default.createElement(_ButtonsListSelectOption2.default, {
        key: option.value,
        value: option.value,
        disabled: option.disabled,
        label: option.label,
        iconClass: option.iconClass,
        infoText: option.infoText,
        onClick: onClick,
        onOpenHelp: onOpenHelp,
        onCloseHelp: onCloseHelp,
        opened: opened && option.infoText,
        selected: selectedOptions.includes(option.value),
        accordion: accordion,
        showCheckbox: showCheckbox,
        dataTest: dataTest || (0, _dataTestHelper2.default)(option.value)
      });
    })
  );
};

ButtonsListSelectOptions.propTypes = {
  options: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    value: _propTypes2.default.string,
    label: _propTypes2.default.string
  }).isRequired).isRequired,
  onClick: _propTypes2.default.func,
  onOpenHelp: _propTypes2.default.func,
  onCloseHelp: _propTypes2.default.func,
  opened: _propTypes2.default.bool,
  accordion: _propTypes2.default.bool,
  showCheckbox: _propTypes2.default.bool,
  selectedOptions: _propTypes2.default.arrayOf(_propTypes2.default.string),
  dataTest: _propTypes2.default.string
};

exports.default = ButtonsListSelectOptions;