'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _exists = require('../utils/exists');

var _exists2 = _interopRequireDefault(_exists);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Checkbox = function Checkbox(props) {
  var id = props.id,
      name = props.name,
      label = props.label,
      className = props.className,
      labelClass = props.labelClass,
      setValue = props.setValue,
      getValue = props.getValue,
      onChange = props.onChange,
      disabled = props.disabled;

  var inputId = id || name;
  var checkboxClassName = (0, _classnames2.default)('form-checkbox', className);

  var handleChange = function handleChange(e) {
    if (onChange) {
      onChange(e);
    }
    setValue(e.target.checked);
  };

  return _react2.default.createElement(
    'div',
    { className: 'form-group form-group--checkbox' },
    _react2.default.createElement(
      'div',
      { className: checkboxClassName },
      _react2.default.createElement('input', {
        type: 'checkbox',
        id: inputId,
        name: name,
        onChange: handleChange,
        checked: (0, _exists2.default)(getValue) ? getValue() : false,
        disabled: disabled
      }),
      _react2.default.createElement('label', { htmlFor: inputId })
    ),
    label && _react2.default.createElement(
      'label',
      { htmlFor: inputId, className: labelClass },
      label
    )
  );
};

Checkbox.propTypes = {
  id: _propTypes2.default.string,
  label: _propTypes2.default.string,
  name: _propTypes2.default.string.isRequired,
  className: _propTypes2.default.string,
  labelClass: _propTypes2.default.string,
  setValue: _propTypes2.default.func,
  getValue: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  disabled: _propTypes2.default.bool
};

exports.default = Checkbox;