'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getCheckboxIconClass = function getCheckboxIconClass(checked) {
  return (0, _classnames2.default)('checkbox-icon', {
    'checkbox-icon--checked': checked,
    'checkbox-icon--unchecked': !checked
  });
};

var CheckboxIcon = function CheckboxIcon(_ref) {
  var checked = _ref.checked,
      onClick = _ref.onClick;
  return _react2.default.createElement('div', { className: getCheckboxIconClass(checked), onClick: onClick });
};

CheckboxIcon.propTypes = {
  checked: _propTypes2.default.bool,
  onClick: _propTypes2.default.func
};

CheckboxIcon.defaultProps = {
  onClick: function onClick() {}
};

exports.default = CheckboxIcon;