'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _exists = require('../utils/exists');

var _exists2 = _interopRequireDefault(_exists);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isNumeric = function isNumeric(value) {
  var regex = new RegExp('-?\\d*(\\.\\d{1,2})?', 'g');
  var match = String(value).match(regex);
  return match[0] === String(value);
};

var formatNumberWithDecimalSeparator = function formatNumberWithDecimalSeparator(number, decimalSeparator) {
  var _String$split = String(number).split('.'),
      _String$split2 = _slicedToArray(_String$split, 2),
      integers = _String$split2[0],
      decimals = _String$split2[1];

  var decimalSection = decimals ? '' + decimalSeparator + decimals : '';

  return '' + integers + decimalSection;
};

var removeThousandsSeparator = function removeThousandsSeparator(str, thousandsSeparator) {
  var regex = new RegExp('\\' + thousandsSeparator, 'g');

  return str.replace(regex, '');
};

var removeInvalidCharacters = function removeInvalidCharacters(str, thousandsSeparator, decimalSeparator) {
  var validValue = removeThousandsSeparator(str, thousandsSeparator);
  var regex = new RegExp('(-?\\d*(?:\\' + decimalSeparator + '\\d{0,2})?)', 'g');
  var match = validValue.match(regex);

  return match ? match[0] : undefined;
};

var addThousandsSeparator = function addThousandsSeparator(value, thousandsSeparator) {
  return String(value).replace(/\B(?=(\d{3})+(?!\d))/g, thousandsSeparator);
};

var convertNextValue = function convertNextValue(value, props) {
  var nextValue = isNumeric(value) ? formatNumberWithDecimalSeparator(value, props.decimalSeparator) : value;
  nextValue = removeInvalidCharacters(nextValue, props.thousandsSeparator, props.decimalSeparator);
  if (!nextValue) {
    return '';
  }
  if (props.max && Number(nextValue) > props.max) {
    nextValue = props.max;
  }
  if (Number(nextValue) < props.min) {
    nextValue = props.min;
  }
  return addThousandsSeparator(nextValue, props.thousandsSeparator);
};

var CurrencyInput = function (_React$Component) {
  _inherits(CurrencyInput, _React$Component);

  function CurrencyInput(props) {
    _classCallCheck(this, CurrencyInput);

    var _this = _possibleConstructorReturn(this, (CurrencyInput.__proto__ || Object.getPrototypeOf(CurrencyInput)).call(this, props));

    _this.handleChange = function (e) {
      _this.setNextValue(e.target.value);
    };

    _this.state = {
      value: convertNextValue((0, _exists2.default)(props.value) ? props.value : '', props)
    };
    return _this;
  }

  _createClass(CurrencyInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.state.value !== nextProps.value) {
        this.setState({
          value: convertNextValue((0, _exists2.default)(nextProps.value) ? nextProps.value : '', nextProps)
        });
      }
    }
  }, {
    key: 'setNextValue',
    value: function setNextValue(value) {
      var nextValue = convertNextValue(value, this.props);
      var numericValue = this.numberFromValue(nextValue);
      var valueHasChanged = numericValue !== this.numberFromValue(this.state.value);
      this.setState({ value: nextValue });
      if (this.props.setValue && valueHasChanged) {
        this.props.setValue(numericValue);
      }
    }
  }, {
    key: 'numberFromValue',
    value: function numberFromValue(value) {
      var validValue = removeThousandsSeparator(value, this.props.thousandsSeparator);
      return isNumeric(validValue) && validValue > 0 ? Number(validValue) : validValue;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          name = _props.name,
          min = _props.min,
          max = _props.max,
          _props$currencyType = _props.currencyType,
          currencyType = _props$currencyType === undefined ? 'dollar' : _props$currencyType,
          width = _props.width,
          _onBlur = _props.onBlur,
          autoFocus = _props.autoFocus,
          disabled = _props.disabled,
          showNumpadKeyboard = _props.showNumpadKeyboard,
          innerRef = _props.innerRef;

      var inputClass = (0, _classnames2.default)('currency-input__input');
      return _react2.default.createElement(
        'div',
        { className: 'currency-input', style: { width: width } },
        _react2.default.createElement('span', { className: 'currency-input__icon currency-input__icon--' + currencyType }),
        _react2.default.createElement('input', {
          ref: innerRef || 'input',
          className: inputClass,
          type: 'text',
          pattern: showNumpadKeyboard ? '[0-9]*' : '.*',
          inputMode: showNumpadKeyboard ? 'decimal' : 'numeric',
          lang: 'en',
          name: name,
          min: min,
          max: max,
          onBlur: function onBlur(e) {
            return _onBlur ? _onBlur(e) : null;
          },
          onChange: this.handleChange,
          value: this.state.value,
          autoFocus: autoFocus,
          disabled: disabled
        })
      );
    }
  }]);

  return CurrencyInput;
}(_react2.default.Component);

var differentPropsValueValidator = function differentPropsValueValidator(props, propName, otherPropName, componentName) {
  if (props[propName] === props[otherPropName]) {
    return new Error('Invalid prop ' + propName + ' supplied to ' + componentName + '. Values of ' + propName + ' and ' + otherPropName + ' must be different.');
  }
};

CurrencyInput.propTypes = {
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  innerRef: _propTypes2.default.func,
  name: _propTypes2.default.string,
  min: _propTypes2.default.number,
  max: _propTypes2.default.number,
  currencyType: _propTypes2.default.string,
  decimalSeparator: function decimalSeparator(props, propName, componentName) {
    return differentPropsValueValidator(props, propName, 'thousandsSeparator', componentName);
  },
  thousandsSeparator: function thousandsSeparator(props, propName, componentName) {
    return differentPropsValueValidator(props, propName, 'decimalSeparator', componentName);
  },
  autoFocus: _propTypes2.default.bool,
  onBlur: _propTypes2.default.func,
  setValue: _propTypes2.default.func,
  width: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  disabled: _propTypes2.default.bool,
  showNumpadKeyboard: _propTypes2.default.bool
};

CurrencyInput.defaultProps = {
  min: Number.MIN_SAFE_INTEGER,
  max: Number.MAX_SAFE_INTEGER,
  decimalSeparator: '.',
  thousandsSeparator: ',',
  disabled: false
};

exports.default = CurrencyInput;