'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CwFlashNotification = function (_React$Component) {
  _inherits(CwFlashNotification, _React$Component);

  function CwFlashNotification(props) {
    _classCallCheck(this, CwFlashNotification);

    var _this = _possibleConstructorReturn(this, (CwFlashNotification.__proto__ || Object.getPrototypeOf(CwFlashNotification)).call(this, props));

    _this.closeNotification = function () {
      _this.setState({
        closed: true
      });
    };

    _this.state = {
      closed: false
    };
    return _this;
  }

  _createClass(CwFlashNotification, [{
    key: 'render',
    value: function render() {
      var closed = this.state.closed;
      var _props = this.props,
          type = _props.type,
          title = _props.title,
          subtitle = _props.subtitle,
          subtitleMobile = _props.subtitleMobile,
          largeTitle = _props.largeTitle,
          largeTitleMobile = _props.largeTitleMobile,
          titleMobile = _props.titleMobile,
          onClose = _props.onClose,
          dataTest = _props.dataTest;

      if (!onClose && closed) {
        return false;
      }
      var notificationClass = (0, _classnames2.default)('cw-flash-notification', 'cw-flash-notification--' + type);

      var handleClose = onClose || this.closeNotification;

      return _react2.default.createElement(
        'div',
        { className: notificationClass, 'data-test': dataTest },
        _react2.default.createElement(
          'aside',
          { className: 'cw-flash-notification__icon-container' },
          _react2.default.createElement('i', { className: 'cw-flash-notification__icon' })
        ),
        _react2.default.createElement(
          'div',
          { className: 'cw-flash-notification__content' },
          title && _react2.default.createElement(
            'h4',
            { className: 'cw-flash-notification__title title-desktop' },
            title
          ),
          title && _react2.default.createElement(
            'h4',
            { className: 'cw-flash-notification__title title-tablet' },
            titleMobile ? titleMobile : title
          ),
          _react2.default.createElement(
            'div',
            { className: 'description-desktop' },
            largeTitle && _react2.default.createElement(
              'h5',
              { className: 'cw-flash-notification__title-large' },
              largeTitle
            ),
            subtitle && _react2.default.createElement(
              'h5',
              { className: 'cw-flash-notification__description' },
              subtitle
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'description-tablet' },
            largeTitle && _react2.default.createElement(
              'h5',
              { className: 'cw-flash-notification__title-large' },
              largeTitleMobile ? largeTitleMobile : largeTitle
            ),
            subtitle && _react2.default.createElement(
              'h5',
              { className: 'cw-flash-notification__description' },
              subtitleMobile ? subtitleMobile : subtitle
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'cw-flash-notification__children' },
            this.props.children
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'cw-flash-notification__controls' },
          _react2.default.createElement(
            'a',
            { className: 'cw-flash-notification__close', onClick: handleClose },
            _react2.default.createElement('i', { className: 'cw-flash-notification__close-icon' })
          )
        )
      );
    }
  }]);

  return CwFlashNotification;
}(_react2.default.Component);

CwFlashNotification.propTypes = {
  children: _propTypes2.default.any,
  type: _propTypes2.default.string.isRequired,
  title: _propTypes2.default.string,
  largeTitle: _propTypes2.default.string,
  subtitle: _propTypes2.default.string,
  onClose: _propTypes2.default.func,
  subtitleMobile: _propTypes2.default.string,
  largeTitleMobile: _propTypes2.default.string,
  titleMobile: _propTypes2.default.string,
  dataTest: _propTypes2.default.string
};

exports.default = CwFlashNotification;