'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function HighLightedText(_ref) {
  var text = _ref.text,
      selection = _ref.selection;

  var inputValue = (selection || '').toLocaleLowerCase();
  var startIndex = text.toLocaleLowerCase().indexOf(inputValue);
  var endIndex = startIndex + inputValue.length;
  return _react2.default.createElement(
    'span',
    null,
    text.substring(0, startIndex),
    _react2.default.createElement(
      'b',
      null,
      text.substring(startIndex, endIndex)
    ),
    text.substring(endIndex, text.length)
  );
}

HighLightedText.propTypes = {
  text: _propTypes2.default.string.isRequired,
  selection: _propTypes2.default.string
};

exports.default = HighLightedText;