'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _IconRadioInput = require('./IconRadioInput');

var _IconRadioInput2 = _interopRequireDefault(_IconRadioInput);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _exists = require('../utils/exists');

var _exists2 = _interopRequireDefault(_exists);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getDataTest = function getDataTest(name) {
  var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var optionValue = option.value;
  if (typeof optionValue === 'boolean') {
    optionValue = optionValue ? 'Yes' : 'No';
  }
  return String(name).replace(/_/g, '-') + '-' + optionValue;
};

var IconRadioGroup = function (_React$Component) {
  _inherits(IconRadioGroup, _React$Component);

  function IconRadioGroup(props) {
    _classCallCheck(this, IconRadioGroup);

    var _this = _possibleConstructorReturn(this, (IconRadioGroup.__proto__ || Object.getPrototypeOf(IconRadioGroup)).call(this, props));

    _this.handleChange = function (value) {
      _this.setState({ value: value });
      if (_this.props.onChange) {
        _this.props.onChange(value);
      }
    };

    _this.state = {
      value: props.value
    };
    return _this;
  }

  _createClass(IconRadioGroup, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.state.value !== nextProps.value && (0, _exists2.default)(nextProps.value)) {
        this.setState({
          value: nextProps.value
        });
      }
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      var value = this.state.value;
      if (this.props.getValue) {
        value = this.props.getValue();
      }
      return value;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          options = _props.options,
          name = _props.name,
          size = _props.size,
          disabled = _props.disabled,
          className = _props.className,
          innerRef = _props.innerRef,
          dataTest = _props.dataTest;

      return _react2.default.createElement(
        'div',
        {
          className: (0, _classnames2.default)('icons-radio-group', {
            'icons-radio-group--disabled': disabled
          }, className)
        },
        options.map(function (option, i) {
          return _react2.default.createElement(_IconRadioInput2.default, {
            innerRef: innerRef,
            key: i,
            iconClass: option.iconClass,
            label: option.label,
            name: name,
            value: option.value,
            recommendable: option.recommendable,
            checkedValue: _this2.getValue(),
            onChange: _this2.handleChange,
            size: size,
            disabled: disabled || option.disabled,
            icon: option.icon,
            dataTest: dataTest || getDataTest(name, option)
          });
        })
      );
    }
  }]);

  return IconRadioGroup;
}(_react2.default.Component);

IconRadioGroup.propTypes = {
  options: _propTypes2.default.arrayOf(_propTypes2.default.object),
  name: _propTypes2.default.string,
  value: _propTypes2.default.any,
  getValue: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  size: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  innerRef: _propTypes2.default.func,
  dataTest: _propTypes2.default.string
};

IconRadioGroup.defaultProps = {
  dataTest: ''
};

exports.default = IconRadioGroup;