'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _deviceDetector = require('../utils/deviceDetector');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var IconRadioInput = function (_React$Component) {
  _inherits(IconRadioInput, _React$Component);

  function IconRadioInput(props) {
    _classCallCheck(this, IconRadioInput);

    var _this = _possibleConstructorReturn(this, (IconRadioInput.__proto__ || Object.getPrototypeOf(IconRadioInput)).call(this, props));

    _this.handleChange = function () {
      if (_this.props.onChange) {
        _this.props.onChange(_this.props.value);
      }
    };

    _this.anyIconGiven = function () {
      return _this.props.iconClass || _this.props.icon;
    };

    _this.state = {
      checked: props.value === props.checkedValue
    };
    return _this;
  }

  _createClass(IconRadioInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ checked: nextProps.value === nextProps.checkedValue });
    }
  }, {
    key: 'renderIcon',
    value: function renderIcon() {
      if (this.anyIconGiven()) {
        return _react2.default.createElement(
          'div',
          { className: 'icons-radio-input__icon' },
          this.props.icon ? this.props.icon() : _react2.default.createElement('span', { className: this.props.iconClass })
        );
      }
      return _react2.default.createElement('span', null);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          name = _props.name,
          value = _props.value,
          label = _props.label,
          size = _props.size,
          disabled = _props.disabled,
          iconClass = _props.iconClass,
          recommendable = _props.recommendable,
          className = _props.className,
          icon = _props.icon,
          innerRef = _props.innerRef,
          dataTest = _props.dataTest;
      var checked = this.state.checked;

      var buttonClass = (0, _classnames2.default)('icons-radio-input', { 'icons-radio-input--checked': checked }, { 'icons-radio-input--no-touch': !(0, _deviceDetector.isIOS)() }, { 'icons-radio-input--small': size === 'small' }, { 'icons-radio-input--disabled': disabled }, { 'icons-radio-input--no-icon': !iconClass && !icon }, { 'icons-radio-input--recommendable': recommendable }, className);
      var inputId = '' + name + value;
      return _react2.default.createElement(
        'label',
        { className: buttonClass, htmlFor: inputId, 'data-test': dataTest },
        this.renderIcon(),
        _react2.default.createElement('input', {
          ref: innerRef,
          id: inputId,
          type: 'radio',
          name: name,
          className: 'icons-radio-input__input',
          onChange: this.handleChange,
          value: value,
          checked: checked,
          disabled: disabled
        }),
        _react2.default.createElement(
          'div',
          {
            className: (0, _classnames2.default)('icons-radio-input__label', {
              'icons-radio-input__label--top-separation': iconClass
            })
          },
          label
        )
      );
    }
  }]);

  return IconRadioInput;
}(_react2.default.Component);

IconRadioInput.propTypes = {
  iconClass: _propTypes2.default.string,
  label: _propTypes2.default.string,
  name: _propTypes2.default.string.isRequired,
  value: _propTypes2.default.any.isRequired,
  checkedValue: _propTypes2.default.any,
  onChange: _propTypes2.default.func.isRequired,
  size: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  recommendable: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  innerRef: _propTypes2.default.func,
  dataTest: _propTypes2.default.string
};

exports.default = IconRadioInput;