'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _numberWithCommas = require('../utils/numberWithCommas');

var _numberWithCommas2 = _interopRequireDefault(_numberWithCommas);

var _exists = require('../utils/exists');

var _exists2 = _interopRequireDefault(_exists);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var convertNextValue = function convertNextValue(value, props) {
  var nextValue = value;
  nextValue = String(nextValue).replace(/[,%]/g, '');
  nextValue = nextValue.indexOf('0') !== -1 ? nextValue : nextValue || '';
  nextValue = props.type === 'number' && nextValue !== '' ? parseInt(nextValue, 10) : nextValue;
  if (props.max && parseInt(nextValue, 10) > props.max) {
    nextValue = props.max;
  }
  if (parseInt(nextValue, 10) <= props.min) {
    nextValue = props.min;
  }
  nextValue = props.commas || props.currency ? (0, _numberWithCommas2.default)(nextValue) : nextValue;
  return nextValue;
};

var NumberInput = function (_React$Component) {
  _inherits(NumberInput, _React$Component);

  function NumberInput(props) {
    _classCallCheck(this, NumberInput);

    var _this = _possibleConstructorReturn(this, (NumberInput.__proto__ || Object.getPrototypeOf(NumberInput)).call(this, props));

    _this.handleChange = function (e) {
      _this.setNextValue(e.target.value);
    };

    _this.handlePlus = function () {
      var inputValue = parseInt(String(_this.refs.input.value).replace(/[,%]/g, ''), 10);
      var number = inputValue || _this.props.firstIncrement - 1 || 0;
      var step = _this.props.step ? _this.props.step : 1;
      var max = _this.props.max ? _this.props.max : null;
      var nextValue = number + step;
      if (max) {
        if (number + step <= max) {
          _this.setNextValue(nextValue);
        }
      } else {
        _this.setNextValue(nextValue);
      }
    };

    _this.handleMinus = function () {
      var inputValue = parseInt(String(_this.refs.input.value).replace(/[,%]/g, ''), 10);
      var number = inputValue || _this.props.firstDecrement + 1 || 0;
      var step = _this.props.step ? _this.props.step : 1;
      var min = _this.props.min ? _this.props.min : 0;
      if (number - step >= min) {
        var nextValue = number - step;
        _this.setNextValue(nextValue);
      }
    };

    _this.state = {
      value: convertNextValue((0, _exists2.default)(props.value) ? props.value : '', props)
    };
    return _this;
  }

  _createClass(NumberInput, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.state.value !== nextProps.value) {
        this.setState({
          value: convertNextValue((0, _exists2.default)(nextProps.value) ? nextProps.value : '', nextProps)
        });
      }
    }
  }, {
    key: 'setNextValue',
    value: function setNextValue(value) {
      var nextValue = convertNextValue(value, this.props);
      this.setState({ value: nextValue });
      if (this.props.setValue) {
        this.props.setValue(nextValue);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          name = _props.name,
          min = _props.min,
          max = _props.max,
          step = _props.step,
          commas = _props.commas,
          percents = _props.percents,
          currency = _props.currency,
          _props$currencyType = _props.currencyType,
          currencyType = _props$currencyType === undefined ? 'dollar' : _props$currencyType,
          type = _props.type,
          width = _props.width,
          _onBlur = _props.onBlur,
          autoFocus = _props.autoFocus,
          showNumpadKeyboard = _props.showNumpadKeyboard,
          placeholder = _props.placeholder,
          disabled = _props.disabled;


      var inputClass = (0, _classnames2.default)('number-input__input', { 'number-input__input--nan number-input__input--currency': currency }, { 'number-input__input--nan': commas || type !== 'number' }, { 'number-input__input--percents': percents });

      return _react2.default.createElement(
        'div',
        { className: 'number-input', style: { width: width } },
        currency && _react2.default.createElement('span', { className: 'number-input__currency number-input__currency--' + currencyType + '-icon' }),
        _react2.default.createElement('input', {
          ref: 'input',
          className: inputClass,
          type: commas || currency || showNumpadKeyboard ? 'text' : type,
          pattern: (commas || percents || currency) && !showNumpadKeyboard ? '.*' : '[0-9]*',
          inputMode: showNumpadKeyboard ? 'decimal' : 'numeric',
          lang: 'en',
          name: name,
          min: min,
          max: max,
          step: step,
          onBlur: function onBlur(e) {
            return _onBlur ? _onBlur(e) : null;
          },
          onChange: this.handleChange,
          value: this.state.value,
          autoFocus: autoFocus,
          placeholder: placeholder,
          disabled: disabled
        }),
        percents && _react2.default.createElement(
          'span',
          { className: 'number-input__percents' },
          '%'
        ),
        !currency && !disabled && _react2.default.createElement('span', { className: 'number-input__minus', onClick: this.handleMinus }),
        !currency && !disabled && _react2.default.createElement('span', { className: 'number-input__plus', onClick: this.handlePlus })
      );
    }
  }]);

  return NumberInput;
}(_react2.default.Component);

NumberInput.propTypes = {
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  name: _propTypes2.default.string,
  type: _propTypes2.default.string,
  min: _propTypes2.default.number,
  max: _propTypes2.default.number,
  firstIncrement: _propTypes2.default.number,
  firstDecrement: _propTypes2.default.number,
  step: _propTypes2.default.number,
  currency: _propTypes2.default.bool,
  currencyType: _propTypes2.default.string,
  commas: _propTypes2.default.bool,
  percents: _propTypes2.default.bool,
  autoFocus: _propTypes2.default.bool,
  onBlur: _propTypes2.default.func,
  setValue: _propTypes2.default.func,
  width: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  placeholder: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  disabled: _propTypes2.default.bool,
  showNumpadKeyboard: _propTypes2.default.bool
};

NumberInput.defaultProps = {
  type: 'number',
  min: 0,
  step: 1
};

exports.default = NumberInput;