'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var handleDropdownClick = function handleDropdownClick(disabled, onDropdownClick, value) {
  return function (e) {
    e.stopPropagation();
    return !disabled && onDropdownClick(value);
  };
};

function OnlyClickDropdownListOption(_ref) {
  var value = _ref.value,
      label = _ref.label,
      addition = _ref.addition,
      checked = _ref.checked,
      tooltipKey = _ref.tooltipKey,
      listType = _ref.listType,
      disabled = _ref.disabled,
      dropdownShowed = _ref.dropdownShowed,
      onDropdownClick = _ref.onDropdownClick,
      openDropdownText = _ref.openDropdownText,
      closeDropdownText = _ref.closeDropdownText,
      dropdownContent = _ref.dropdownContent;

  var containerClass = (0, _classnames2.default)('oc-dropdown-item', 'oc-dropdown-item__container', { 'oc-dropdown-item__container--checked': checked }, { 'oc-dropdown-item__container--opened': dropdownShowed });
  var contentClass = (0, _classnames2.default)('oc-dropdown-item__content');
  var headClasses = (0, _classnames2.default)('oc-dropdown-item__head');
  var dropdownClasses = (0, _classnames2.default)('oc-dropdown-item__head-info', 'oc-dropdown-item__dropdown-text');
  var messageClass = (0, _classnames2.default)('oc-option__message', 'oc-dropdown-item__head-info');
  var multiSelectIconClass = (0, _classnames2.default)('oc-dropdown-item__icon', 'oc-dropdown-item__head-info');

  var dropdownIconClass = (0, _classnames2.default)(dropdownShowed ? 'oc-dropdown-item__up-icon' : 'oc-dropdown-item__down-icon');
  var dropdownText = dropdownShowed ? closeDropdownText : openDropdownText;
  return _react2.default.createElement(
    'div',
    { className: containerClass },
    _react2.default.createElement(
      'div',
      { className: headClasses },
      listType === 'multiSelect' && _react2.default.createElement('span', { className: multiSelectIconClass }),
      _react2.default.createElement(
        'span',
        { className: messageClass },
        label,
        addition && _react2.default.createElement(
          'div',
          { className: 'oc-option__addition' },
          addition
        )
      ),
      _react2.default.createElement(
        'span',
        { onClick: handleDropdownClick(disabled, onDropdownClick, value), className: dropdownClasses },
        _react2.default.createElement(
          'span',
          null,
          dropdownText
        ),
        _react2.default.createElement('i', { className: dropdownIconClass })
      )
    ),
    _react2.default.createElement(
      'div',
      { className: contentClass },
      dropdownContent
    )
  );
}

OnlyClickDropdownListOption.propTypes = {
  value: _propTypes2.default.string.isRequired,
  label: _propTypes2.default.string.isRequired,
  addition: _propTypes2.default.string,
  tooltipKey: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  checked: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  listType: _propTypes2.default.string,
  onDropdownClick: _propTypes2.default.func,
  dropdownShowed: _propTypes2.default.bool,
  openDropdownText: _propTypes2.default.string,
  closeDropdownText: _propTypes2.default.string,
  dropdownContent: _propTypes2.default.func
};

exports.default = OnlyClickDropdownListOption;