'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _smoothscroll = require('smoothscroll');

var _smoothscroll2 = _interopRequireDefault(_smoothscroll);

var _take = require('lodash/take');

var _take2 = _interopRequireDefault(_take);

var _OnlyClickListOptions = require('./OnlyClickListOptions');

var _OnlyClickListOptions2 = _interopRequireDefault(_OnlyClickListOptions);

var _OnlyClickIconOptions = require('./OnlyClickIconOptions');

var _OnlyClickIconOptions2 = _interopRequireDefault(_OnlyClickIconOptions);

var _stringHelper = require('../utils/string-helper');

var _stringHelper2 = _interopRequireDefault(_stringHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var filterOption = function filterOption(option, typedValue) {
  var text = typedValue.toLowerCase();
  var regexInput = new RegExp((0, _stringHelper2.default)(text));
  return regexInput.test(option.value.toLowerCase());
};

var OnlyClickHideableSelect = function (_React$Component) {
  _inherits(OnlyClickHideableSelect, _React$Component);

  function OnlyClickHideableSelect(props) {
    _classCallCheck(this, OnlyClickHideableSelect);

    var _this = _possibleConstructorReturn(this, (OnlyClickHideableSelect.__proto__ || Object.getPrototypeOf(OnlyClickHideableSelect)).call(this, props));

    _this.setFocusOnInput = function () {
      _this.refs['text-input'].focus();
    };

    _this.triggerIsShowSelectOptions = function (nextProps) {
      if (!_this.refs['oc-select'].contains(nextProps.clickedElement)) {
        _this.setState({ isShowSelectOptions: false });
      }
    };

    _this.handleChange = function (e) {
      var typedValue = _this.state.typedValue;


      if (typedValue !== e.target.value) {
        _this.setState({ isShowSelectOptions: true });
      }

      var value = e.target.value;
      _this.setState({ typedValue: value }, function () {
        if (_this.props.onChange) {
          _this.props.onChange(value);
        }
      });
    };

    _this.handleFocus = function () {
      _this.setState({ isShowSelectOptions: true });
    };

    _this.handleClick = function (value) {
      var values = _this.state.values;


      if (values.indexOf(value) === -1) {
        _this.setState({ values: [].concat(_toConsumableArray(values), [value]), isShowSelectOptions: false, typedValue: '' });

        if (_this.props.onClick) {
          _this.props.onClick(value);
        }
      } else {
        _this.handleDelete(value);
      }
      if (_this.shouldScroll()) {
        _this.scrollToInput();
      } else if (_this.shouldFocus()) {
        _this.setFocusOnInput();
      }
    };

    _this.handleKeyPress = function (e) {
      var onEnterKeyPress = _this.props.onEnterKeyPress;


      if (onEnterKeyPress && e.key === 'Enter') {
        var value = e.target.value;

        onEnterKeyPress(value);
      }
    };

    _this.handleKeyDown = function (e) {
      if (e.keyCode === 27) {
        _this.setState({ isShowSelectOptions: false });
      }
    };

    _this.mobileWidth = 480;
    _this.state = {
      values: props.values,
      typedValue: props.defaultValue || '',
      isShowSelectOptions: false
    };
    return _this;
  }

  _createClass(OnlyClickHideableSelect, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var nextState = { values: nextProps.values };
      this.setState(nextState);

      if (nextProps.clickedElement && this.props.clickedElement !== nextProps.clickedElement) {
        this.triggerIsShowSelectOptions(nextProps);
      }
    }
  }, {
    key: 'getFilteredOptions',
    value: function getFilteredOptions(typedValue) {
      var _this2 = this;

      var _props = this.props,
          options = _props.options,
          maxVisible = _props.maxVisible;


      var filteredOptions = options.filter(function (option) {
        if (_this2.props.filterOption) {
          return _this2.props.filterOption(option, typedValue);
        }
        return filterOption(option, typedValue);
      });

      return (0, _take2.default)(filteredOptions, maxVisible);
    }
  }, {
    key: 'propsChanged',
    value: function propsChanged(nextProps) {
      return this.props.type !== nextProps.type || this.props.values.length !== nextProps.values.length || this.props.options.length !== nextProps.options.length;
    }
  }, {
    key: 'scrollToInput',
    value: function scrollToInput() {
      var _this3 = this;

      var searchBox = this.refs['search-box'];
      var input = this.refs['text-input'];
      var scrollTop = this.props.scrollTop || 100;
      var scrollToPosition = searchBox.getBoundingClientRect().top + (window.pageYOffset - scrollTop);
      (0, _smoothscroll2.default)(scrollToPosition, 1000, function () {
        if (_this3.props.autoFocus) {
          input.focus();
        }
      });
    }
  }, {
    key: 'shouldScroll',
    value: function shouldScroll() {
      var searchBox = this.refs['search-box'];
      var pixelsToElement = searchBox.getBoundingClientRect().top;
      return this.props.autoScroll && pixelsToElement < 0;
    }
  }, {
    key: 'shouldFocus',
    value: function shouldFocus() {
      return this.props.autoFocus && window && window.innerWidth > this.mobileWidth;
    }
  }, {
    key: 'handleDelete',
    value: function handleDelete(value) {
      var values = this.state.values;

      if (values.indexOf(value) !== -1) {
        this.setState({
          values: values.filter(function (val) {
            return value !== val;
          })
        });
      }
      if (this.props.onDelete) {
        this.props.onDelete(value);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props2 = this.props,
          type = _props2.type,
          options = _props2.options,
          placeholder = _props2.placeholder,
          hint = _props2.hint,
          errorMessage = _props2.errorMessage,
          highlight = _props2.highlight,
          highlightSanitizer = _props2.highlightSanitizer,
          maxVisible = _props2.maxVisible,
          onHelpIconClick = _props2.onHelpIconClick,
          disableFilter = _props2.disableFilter,
          disableInput = _props2.disableInput,
          disableDelete = _props2.disableDelete,
          animatedSelection = _props2.animatedSelection;
      var _state = this.state,
          values = _state.values,
          typedValue = _state.typedValue;
      var isShowSelectOptions = this.state.isShowSelectOptions;

      var filteredOptions = disableFilter ? (0, _take2.default)(options, maxVisible) : this.getFilteredOptions(typedValue);

      isShowSelectOptions = isShowSelectOptions && !!filteredOptions.length;

      return _react2.default.createElement(
        'div',
        { className: 'oc-select oc-select--hideable', ref: 'oc-select' },
        _react2.default.createElement(
          'div',
          { className: 'oc-select__search-container' },
          _react2.default.createElement(
            'div',
            { className: 'oc-select__search', ref: 'search-box', onClick: this.setFocusOnInput },
            values.map(function (value) {
              return _react2.default.createElement(
                'span',
                { className: 'oc-selected-value', key: value },
                value,
                !disableDelete && _react2.default.createElement('span', { className: 'oc-selected-value__close-icon', onClick: function onClick() {
                    return _this4.handleDelete(value);
                  } })
              );
            }),
            _react2.default.createElement(
              'div',
              { className: 'oc-select__input-container' },
              _react2.default.createElement('input', {
                ref: 'text-input',
                className: 'oc-select__input',
                type: 'text',
                placeholder: placeholder,
                value: typedValue,
                onChange: this.handleChange,
                onKeyPress: this.handleKeyPress,
                onKeyDown: this.handleKeyDown,
                onFocus: this.handleFocus,
                disabled: disableInput
              })
            )
          )
        ),
        hint && _react2.default.createElement(
          'div',
          { className: 'oc-select__hint' },
          hint
        ),
        errorMessage && _react2.default.createElement(
          'div',
          { className: 'oc-select__error' },
          errorMessage
        ),
        isShowSelectOptions && _react2.default.createElement(
          'div',
          { className: 'oc-select__options-container' },
          type === 'icons' ? _react2.default.createElement(_OnlyClickIconOptions2.default, {
            options: filteredOptions,
            selectedValues: values,
            onClick: this.handleClick,
            onHelpClick: onHelpIconClick
          }) : _react2.default.createElement(_OnlyClickListOptions2.default, {
            options: filteredOptions,
            selectedValues: values,
            onClick: this.handleClick,
            typedValue: typedValue,
            highlight: highlight,
            highlightSanitizer: highlightSanitizer,
            animatedSelection: animatedSelection
          })
        )
      );
    }
  }]);

  return OnlyClickHideableSelect;
}(_react2.default.Component);

OnlyClickHideableSelect.propTypes = {
  defaultValue: _propTypes2.default.string,
  type: _propTypes2.default.string,
  hint: _propTypes2.default.string,
  errorMessage: _propTypes2.default.string,
  placeholder: _propTypes2.default.string,
  options: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
  values: _propTypes2.default.arrayOf(_propTypes2.default.string),
  filterOption: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onClick: _propTypes2.default.func,
  onDelete: _propTypes2.default.func,
  onHelpIconClick: _propTypes2.default.func,
  onEnterKeyPress: _propTypes2.default.func,
  disableFilter: _propTypes2.default.bool,
  disableDelete: _propTypes2.default.bool,
  autoFocus: _propTypes2.default.bool,
  highlight: _propTypes2.default.bool,
  highlightSanitizer: _propTypes2.default.func,
  disableInput: _propTypes2.default.bool,
  autoScroll: _propTypes2.default.bool,
  scrollTop: _propTypes2.default.number,
  maxVisible: _propTypes2.default.number,
  hideableOptions: _propTypes2.default.bool,
  animatedSelection: _propTypes2.default.bool,
  clickedElement: _propTypes2.default.object
};

OnlyClickHideableSelect.defaultProps = {
  defaultValue: '',
  values: [],
  maxVisible: 1000
};

exports.default = OnlyClickHideableSelect;