'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _deviceDetector = require('../utils/deviceDetector');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function OnlyClickIconOption(props) {
  var id = props.id,
      value = props.value,
      label = props.label,
      checked = props.checked,
      disabled = props.disabled,
      recommendable = props.recommendable,
      iconClass = props.iconClass,
      _onClick = props.onClick,
      textContent = props.textContent,
      iconClassForCheckedState = props.iconClassForCheckedState,
      dataTest = props.dataTest;

  var optionClass = (0, _classnames2.default)('oc-icon-option', { 'oc-icon-option--checked': checked }, { 'oc-icon-option--disabled': disabled }, { 'oc-icon-option--recommendable': recommendable }, { 'oc-icon-option--no-touch': !(0, _deviceDetector.isIOS)() });

  var isCheckedIcon = checked && iconClassForCheckedState;
  var finalIconClass = isCheckedIcon ? iconClassForCheckedState : iconClass;

  var iconClasses = (0, _classnames2.default)('oc-icon-option__icon', _defineProperty({}, finalIconClass, finalIconClass));

  var dataTestValue = dataTest + '-' + String(value).toLowerCase().replace(' ', '-');

  return _react2.default.createElement(
    'div',
    { id: id, className: optionClass, onClick: function onClick() {
        return !disabled && _onClick(value);
      }, 'data-test': dataTestValue },
    _react2.default.createElement(
      'div',
      { className: 'oc-icon-option__content-container' },
      _react2.default.createElement(
        'div',
        { className: 'oc-icon-option__content' },
        _react2.default.createElement(
          'div',
          { className: 'oc-icon-option__icon-container' },
          _react2.default.createElement('span', { className: iconClasses }),
          !isCheckedIcon && _react2.default.createElement(
            'div',
            { className: 'oc-icon-option__text-content' },
            textContent
          )
        ),
        _react2.default.createElement(
          'div',
          { className: 'oc-icon-option__label' },
          label
        )
      )
    )
  );
}

OnlyClickIconOption.propTypes = {
  value: _propTypes2.default.string.isRequired,
  label: _propTypes2.default.string.isRequired,
  id: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  checked: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  recommendable: _propTypes2.default.bool,
  iconClass: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  textContent: _propTypes2.default.string,
  iconClassForCheckedState: _propTypes2.default.string,
  dataTest: _propTypes2.default.string
};

exports.default = OnlyClickIconOption;