'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _OnlyClickIconOption = require('./OnlyClickIconOption');

var _OnlyClickIconOption2 = _interopRequireDefault(_OnlyClickIconOption);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var noOp = function noOp() {};

function OnlyClickIconOptions(props) {
  var selectedValues = props.selectedValues,
      onClick = props.onClick,
      onHelpClick = props.onHelpClick,
      _props$onTooltipEnter = props.onTooltipEnter,
      onTooltipEnter = _props$onTooltipEnter === undefined ? noOp : _props$onTooltipEnter,
      _props$onTooltipOut = props.onTooltipOut,
      onTooltipOut = _props$onTooltipOut === undefined ? noOp : _props$onTooltipOut,
      dataTest = props.dataTest;

  return _react2.default.createElement(
    'div',
    { className: 'oc-icon-options' },
    props.options.map(function (option) {
      return _react2.default.createElement(
        'div',
        { className: 'oc-icon-options__item oc-icon-option-container', key: option.value },
        _react2.default.createElement(_OnlyClickIconOption2.default, _extends({
          checked: selectedValues.indexOf(option.value) !== -1,
          onClick: onClick
        }, option, {
          dataTest: dataTest
        })),
        option.tooltipKey && _react2.default.createElement('span', {
          className: 'oc-icon-options__item-help-icon',
          id: option.tooltipKey,
          onClick: onHelpClick && onHelpClick.bind(null, option.tooltipKey),
          onMouseEnter: onTooltipEnter,
          onFocus: onTooltipEnter,
          onMouseOut: onTooltipOut,
          onBlur: onTooltipOut,
          tabIndex: '-1'
        })
      );
    })
  );
}

OnlyClickIconOptions.propTypes = {
  options: _propTypes2.default.arrayOf(_propTypes2.default.object),
  onClick: _propTypes2.default.func,
  onHelpClick: _propTypes2.default.func,
  onTooltipEnter: _propTypes2.default.func,
  onTooltipOut: _propTypes2.default.func,
  selectedValues: _propTypes2.default.arrayOf(_propTypes2.default.string),
  dataTest: _propTypes2.default.string
};

exports.default = OnlyClickIconOptions;