'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _OnlyClickListOption = require('./OnlyClickListOption');

var _OnlyClickListOption2 = _interopRequireDefault(_OnlyClickListOption);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _dataTestHelper = require('../utils/dataTestHelper');

var _dataTestHelper2 = _interopRequireDefault(_dataTestHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function OnlyClickListOptions(props) {
  var options = props.options,
      selectedValues = props.selectedValues,
      typedValue = props.typedValue,
      highlight = props.highlight,
      highlightSanitizer = props.highlightSanitizer,
      listType = props.listType,
      onClick = props.onClick,
      onHelpClick = props.onHelpClick,
      disabled = props.disabled,
      listClasses = props.listClasses,
      optionComponent = props.optionComponent,
      animatedSelection = props.animatedSelection,
      withArrows = props.withArrows,
      scrollable = props.scrollable,
      dataTest = props.dataTest;


  return _react2.default.createElement(
    'ul',
    {
      className: (0, _classnames2.default)('oc-list-options', listClasses, {
        'oc-list-options--disabled': disabled
      })
    },
    options.map(function (option, i) {
      return _react2.default.createElement(_OnlyClickListOption2.default, _extends({
        key: option.value + i,
        checked: selectedValues ? selectedValues.indexOf(option.value) !== -1 : false,
        typedValue: typedValue,
        highlight: highlight,
        highlightSanitizer: highlightSanitizer,
        listType: listType,
        onClick: onClick,
        onHelpClick: onHelpClick
      }, option, props, {
        disabled: disabled || option.disabled,
        optionComponent: optionComponent,
        animatedSelection: animatedSelection,
        withArrow: withArrows,
        dataTest: dataTest || (0, _dataTestHelper2.default)(option.value)
      }));
    })
  );
}

OnlyClickListOptions.propTypes = {
  options: _propTypes2.default.arrayOf(_propTypes2.default.object),
  onClick: _propTypes2.default.func,
  onHelpClick: _propTypes2.default.func,
  selectedValues: _propTypes2.default.arrayOf(_propTypes2.default.string),
  typedValue: _propTypes2.default.string,
  highlight: _propTypes2.default.bool,
  animatedSelection: _propTypes2.default.bool,
  highlightSanitizer: _propTypes2.default.func,
  listType: _propTypes2.default.string,
  listClasses: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  optionComponent: _propTypes2.default.func,
  withArrows: _propTypes2.default.bool,
  scrollable: _propTypes2.default.bool,
  dataTest: _propTypes2.default.string
};

exports.default = OnlyClickListOptions;