'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _OnlyClickListOptions = require('./OnlyClickListOptions');

var _OnlyClickListOptions2 = _interopRequireDefault(_OnlyClickListOptions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OnlyClickMultiSelect = function (_React$Component) {
  _inherits(OnlyClickMultiSelect, _React$Component);

  function OnlyClickMultiSelect(props) {
    _classCallCheck(this, OnlyClickMultiSelect);

    var _this = _possibleConstructorReturn(this, (OnlyClickMultiSelect.__proto__ || Object.getPrototypeOf(OnlyClickMultiSelect)).call(this, props));

    _this.handleClick = function (value) {
      var values = _this.state.values;

      if (values.indexOf(value) === -1) {
        _this.setState({ values: [].concat(_toConsumableArray(values), [value]) });
        if (_this.props.onClick) {
          _this.props.onClick(value);
        }
      } else {
        _this.handleDelete(value);
      }
    };

    _this.state = {
      values: props.values
    };
    return _this;
  }

  _createClass(OnlyClickMultiSelect, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var nextState = { values: nextProps.values };
      this.setState(nextState);
    }
  }, {
    key: 'propsChanged',
    value: function propsChanged(nextProps) {
      return this.props.values.length !== nextProps.values.length || this.props.options.length !== nextProps.options.length;
    }
  }, {
    key: 'handleDelete',
    value: function handleDelete(value) {
      var values = this.state.values;

      if (values.indexOf(value) !== -1) {
        this.setState({
          values: values.filter(function (val) {
            return value !== val;
          })
        });
      }
      if (this.props.onDelete) {
        this.props.onDelete(value);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          options = _props.options,
          hint = _props.hint,
          errorMessage = _props.errorMessage,
          onHelpIconClick = _props.onHelpIconClick,
          dataTest = _props.dataTest;
      var values = this.state.values;

      return _react2.default.createElement(
        'div',
        { className: 'oc-multi-select' },
        hint && _react2.default.createElement(
          'div',
          { className: 'oc-multi-select__hint' },
          hint
        ),
        errorMessage && _react2.default.createElement(
          'div',
          { className: 'oc-multi-select__error' },
          errorMessage
        ),
        _react2.default.createElement(
          'div',
          { className: 'oc-multi-select__options-container' },
          _react2.default.createElement(_OnlyClickListOptions2.default, {
            listType: 'multiSelect',
            options: options,
            selectedValues: values,
            onClick: this.handleClick,
            onHelpClick: onHelpIconClick,
            dataTest: dataTest
          })
        )
      );
    }
  }]);

  return OnlyClickMultiSelect;
}(_react2.default.Component);

OnlyClickMultiSelect.propTypes = {
  hint: _propTypes2.default.string,
  errorMessage: _propTypes2.default.string,
  options: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
  values: _propTypes2.default.arrayOf(_propTypes2.default.string),
  onClick: _propTypes2.default.func,
  onDelete: _propTypes2.default.func,
  onHelpIconClick: _propTypes2.default.func,
  dataTest: _propTypes2.default.string
};

OnlyClickMultiSelect.defaultProps = {
  values: [],
  dataTest: ''
};

exports.default = OnlyClickMultiSelect;