'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _OnlyClickListOptions = require('./OnlyClickListOptions');

var _OnlyClickListOptions2 = _interopRequireDefault(_OnlyClickListOptions);

var _OnlyClickDropdownListOption = require('./OnlyClickDropdownListOption');

var _OnlyClickDropdownListOption2 = _interopRequireDefault(_OnlyClickDropdownListOption);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var OnlyClickMultiSelectDropdown = function (_React$Component) {
  _inherits(OnlyClickMultiSelectDropdown, _React$Component);

  function OnlyClickMultiSelectDropdown(props) {
    _classCallCheck(this, OnlyClickMultiSelectDropdown);

    var _this = _possibleConstructorReturn(this, (OnlyClickMultiSelectDropdown.__proto__ || Object.getPrototypeOf(OnlyClickMultiSelectDropdown)).call(this, props));

    _this.getOptions = function () {
      var options = _this.props.options;
      var openedItems = _this.state.openedItems;

      return options.map(function (option) {
        return _extends({}, option, { dropdownShowed: openedItems.includes(option.value) });
      });
    };

    _this.handleDropdownClick = function (value) {
      var _this$state$openedIte = _this.state.openedItems,
          openedItems = _this$state$openedIte === undefined ? [] : _this$state$openedIte;

      var valueIndex = openedItems.indexOf(value);
      if (valueIndex !== -1) {
        openedItems.splice(valueIndex, 1);
      } else {
        openedItems.push(value);
      }
      _this.setState({ openedItems: openedItems });
    };

    _this.handleMultiselectClick = function (value) {
      var values = _this.state.values;

      if (values.indexOf(value) === -1) {
        _this.setState({ values: [].concat(_toConsumableArray(values), [value]) });
        if (_this.props.onClick) {
          _this.props.onClick(value);
        }
      } else {
        _this.handleDelete(value);
      }
    };

    _this.handleNonMultiselectClick = function (value) {
      var values = _this.state.values;

      _this.setState({ values: [value] });
      if (_this.props.onClick) {
        _this.props.onClick(value);
      }
    };

    _this.state = {
      openedItems: [],
      values: props.values
    };
    return _this;
  }

  _createClass(OnlyClickMultiSelectDropdown, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var nextState = { values: nextProps.values };
      this.setState(nextState);
    }
  }, {
    key: 'propsChanged',
    value: function propsChanged(nextProps) {
      return this.props.values.length !== nextProps.values.length || this.props.options.length !== nextProps.options.length;
    }
  }, {
    key: 'handleDelete',
    value: function handleDelete(value) {
      var values = this.state.values;

      if (values.indexOf(value) !== -1) {
        this.setState({
          values: values.filter(function (val) {
            return value !== val;
          })
        });
      }
      if (this.props.onDelete) {
        this.props.onDelete(value);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          hint = _props.hint,
          errorMessage = _props.errorMessage,
          onHelpIconClick = _props.onHelpIconClick,
          openText = _props.openText,
          closeText = _props.closeText,
          multiselect = _props.multiselect;
      var values = this.state.values;

      var handleClick = multiselect ? this.handleMultiselectClick : this.handleNonMultiselectClick;

      return _react2.default.createElement(
        'div',
        { className: 'oc-multi-select-dropdown' },
        hint && _react2.default.createElement(
          'div',
          { className: 'oc-multi-select-dropdown__hint' },
          hint
        ),
        errorMessage && _react2.default.createElement(
          'div',
          { className: 'oc-multi-select-dropdown__error' },
          errorMessage
        ),
        _react2.default.createElement(_OnlyClickListOptions2.default, {
          listType: 'multiSelect',
          options: this.getOptions(),
          selectedValues: values,
          onClick: handleClick,
          onHelpClick: onHelpIconClick,
          onDropdownClick: this.handleDropdownClick,
          openDropdownText: openText,
          closeDropdownText: closeText,
          listClasses: 'oc-multi-select-dropdown__list-items',
          itemClasses: 'oc-multi-select-dropdown__item',
          optionComponent: _OnlyClickDropdownListOption2.default
        })
      );
    }
  }]);

  return OnlyClickMultiSelectDropdown;
}(_react2.default.Component);

OnlyClickMultiSelectDropdown.propTypes = {
  hint: _propTypes2.default.string,
  errorMessage: _propTypes2.default.string,
  options: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
  values: _propTypes2.default.arrayOf(_propTypes2.default.string),
  onClick: _propTypes2.default.func,
  onDelete: _propTypes2.default.func,
  onHelpIconClick: _propTypes2.default.func,
  openText: _propTypes2.default.string,
  closeText: _propTypes2.default.string,
  multiselect: _propTypes2.default.bool
};

OnlyClickMultiSelectDropdown.defaultProps = {
  values: []
};

exports.default = OnlyClickMultiSelectDropdown;