'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _smoothscroll = require('smoothscroll');

var _smoothscroll2 = _interopRequireDefault(_smoothscroll);

var _take = require('lodash/take');

var _take2 = _interopRequireDefault(_take);

var _OnlyClickListOptions = require('./OnlyClickListOptions');

var _OnlyClickListOptions2 = _interopRequireDefault(_OnlyClickListOptions);

var _OnlyClickIconOptions = require('./OnlyClickIconOptions');

var _OnlyClickIconOptions2 = _interopRequireDefault(_OnlyClickIconOptions);

var _stringHelper = require('../utils/string-helper');

var _stringHelper2 = _interopRequireDefault(_stringHelper);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var filterOption = function filterOption(option, typedValue) {
  var text = typedValue.toLowerCase();
  var regexInput = new RegExp((0, _stringHelper2.default)(text));
  return regexInput.test(option.value.toLowerCase());
};

var OnlyClickSelect = function (_React$Component) {
  _inherits(OnlyClickSelect, _React$Component);

  function OnlyClickSelect(props) {
    _classCallCheck(this, OnlyClickSelect);

    var _this = _possibleConstructorReturn(this, (OnlyClickSelect.__proto__ || Object.getPrototypeOf(OnlyClickSelect)).call(this, props));

    _this.handleFocus = function () {
      _this.refs['text-input'].focus();
    };

    _this.toggleDropdown = function () {
      _this.setState({ openDropdown: !_this.state.openDropdown });
    };

    _this.handleChange = function (e) {
      var value = e.target.value;
      _this.setState({ typedValue: value }, function () {
        if (_this.props.onChange) {
          _this.props.onChange(value);
        }
      });
    };

    _this.handleShowIcons = function () {
      var _this$props = _this.props,
          onTrack = _this$props.onTrack,
          trackName = _this$props.trackName,
          trackEvent = _this$props.trackEvent,
          hideMessage = _this$props.hideMessage,
          showMessage = _this$props.showMessage;

      if (onTrack && trackName) {
        trackEvent.buttonName = _this.state.showIcons ? hideMessage : showMessage;
        onTrack(trackName, trackEvent);
      }
      _this.setState({ showIcons: !_this.state.showIcons });
    };

    _this.handleClick = function (value) {
      var values = _this.state.values;
      var _this$props2 = _this.props,
          onClick = _this$props2.onClick,
          resetTypedValue = _this$props2.resetTypedValue,
          hideInput = _this$props2.hideInput;

      if (values.indexOf(value) === -1) {
        _this.setState({ values: [].concat(_toConsumableArray(values), [value]) });

        if (resetTypedValue) {
          _this.setState({ typedValue: '' });
        }

        if (onClick) {
          onClick(value);
        }
      } else {
        _this.handleDelete(value);
      }
      if (_this.shouldScroll()) {
        _this.scrollToInput();
      } else if (_this.shouldFocus()) {
        _this.handleFocus();
      }
    };

    _this.handleKeyPress = function (e) {
      var onEnterKeyPress = _this.props.onEnterKeyPress;

      if (onEnterKeyPress && e.key === 'Enter') {
        var value = e.target.value;

        onEnterKeyPress(value);
      }
    };

    _this.selectedValueLabel = function (value) {
      var _this$props3 = _this.props,
          options = _this$props3.options,
          showOptionLabel = _this$props3.showOptionLabel;

      if (showOptionLabel) {
        var option = options.find(function (o) {
          return o.value === value;
        });

        if (!!option) return option.label;
      }

      return value;
    };

    _this.mobileWidth = 480;
    _this.state = {
      values: props.values,
      typedValue: props.defaultValue || '',
      openDropdown: props.dropdown && props.openedDropdown,
      showIcons: false
    };
    return _this;
  }

  _createClass(OnlyClickSelect, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var nextState = { values: nextProps.values, openDropdown: nextProps.dropdown && nextProps.openedDropdown };
      this.setState(nextState);
    }
  }, {
    key: 'getFilteredOptions',
    value: function getFilteredOptions(typedValue) {
      var _this2 = this;

      var _props = this.props,
          options = _props.options,
          maxVisible = _props.maxVisible;

      var filteredOptions = options.filter(function (option) {
        if (_this2.props.filterOption) {
          return _this2.props.filterOption(option, typedValue);
        }
        return filterOption(option, typedValue);
      });

      return (0, _take2.default)(filteredOptions, maxVisible);
    }
  }, {
    key: 'propsChanged',
    value: function propsChanged(nextProps) {
      return this.props.type !== nextProps.type || this.props.values.length !== nextProps.values.length || this.props.options.length !== nextProps.options.length;
    }
  }, {
    key: 'scrollToInput',
    value: function scrollToInput() {
      var _this3 = this;

      var searchBox = this.refs['search-box'];
      var input = this.refs['text-input'];
      var scrollTop = this.props.scrollTop || 100;
      var scrollToPosition = searchBox.getBoundingClientRect().top + (window.pageYOffset - scrollTop);
      (0, _smoothscroll2.default)(scrollToPosition, 1000, function () {
        if (_this3.props.autoFocus) {
          input.focus();
        }
      });
    }
  }, {
    key: 'shouldScroll',
    value: function shouldScroll() {
      var hideInput = this.props.hideInput;

      if (hideInput) {
        return false;
      }
      var searchBox = this.refs['search-box'];
      var pixelsToElement = searchBox.getBoundingClientRect().top;
      return this.props.autoScroll && pixelsToElement < 0;
    }
  }, {
    key: 'shouldFocus',
    value: function shouldFocus() {
      var hideInput = this.props.hideInput;

      if (hideInput) {
        return false;
      }
      return this.props.autoFocus && window && window.innerWidth > this.mobileWidth;
    }
  }, {
    key: 'handleDelete',
    value: function handleDelete(value, e) {
      var values = this.state.values;

      if (e) {
        e.preventDefault();
        e.stopPropagation();
      }
      if (values.indexOf(value) !== -1) {
        this.setState({
          values: values.filter(function (val) {
            return value !== val;
          })
        });
      }
      if (this.props.onDelete) {
        this.props.onDelete(value);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props2 = this.props,
          type = _props2.type,
          options = _props2.options,
          placeholder = _props2.placeholder,
          hint = _props2.hint,
          errorMessage = _props2.errorMessage,
          highlight = _props2.highlight,
          highlightSanitizer = _props2.highlightSanitizer,
          maxVisible = _props2.maxVisible,
          onHelpIconClick = _props2.onHelpIconClick,
          disableFilter = _props2.disableFilter,
          disableInput = _props2.disableInput,
          disableDelete = _props2.disableDelete,
          onTooltipEnter = _props2.onTooltipEnter,
          onTooltipOut = _props2.onTooltipOut,
          scrollable = _props2.scrollable,
          dropdown = _props2.dropdown,
          openedDropdown = _props2.openedDropdown,
          smallInput = _props2.smallInput,
          grayBorder = _props2.grayBorder,
          noArrows = _props2.noArrows,
          hideInput = _props2.hideInput,
          showOptionLabel = _props2.showOptionLabel,
          dataTest = _props2.dataTest,
          hideIcons = _props2.hideIcons,
          showMessage = _props2.showMessage,
          hideMessage = _props2.hideMessage;
      var _state = this.state,
          values = _state.values,
          typedValue = _state.typedValue,
          openDropdown = _state.openDropdown,
          showIcons = _state.showIcons;

      var filteredOptions = disableFilter ? (0, _take2.default)(options, maxVisible) : this.getFilteredOptions(typedValue);
      var optionsContainerClassName = (0, _classnames2.default)('oc-select__options-container', {
        'oc-select__options-container--scrollable': scrollable,
        'oc-select__options-container--dropdown': dropdown
      });
      var optionSearchClassName = (0, _classnames2.default)('oc-select__search', { 'oc-select__search--dropdown': dropdown }, { 'oc-select__search--small-input': smallInput }, { 'oc-select__search--gray-border': grayBorder });
      var inputClassName = (0, _classnames2.default)('oc-select__input', { 'oc-select__input--no-margin': smallInput });
      var shouldRenderInput = !dropdown || values.length === 0;

      return _react2.default.createElement(
        'div',
        { className: 'oc-select' },
        !hideInput && _react2.default.createElement(
          'div',
          { className: 'oc-select__search-container' },
          _react2.default.createElement(
            'div',
            { className: optionSearchClassName, ref: 'search-box', onClick: dropdown ? this.toggleDropdown : this.handleFocus },
            values.map(function (value) {
              return _react2.default.createElement(
                'span',
                { className: 'oc-selected-value', key: _this4.selectedValueLabel(value) },
                _this4.selectedValueLabel(value),
                !disableDelete && _react2.default.createElement('span', { className: 'oc-selected-value__close-icon', onClick: function onClick(e) {
                    return _this4.handleDelete(value, e);
                  } })
              );
            }),
            shouldRenderInput && _react2.default.createElement(
              'div',
              { className: 'oc-select__input-container' },
              _react2.default.createElement('input', {
                ref: 'text-input',
                className: inputClassName,
                type: 'text',
                placeholder: placeholder,
                value: typedValue,
                onChange: this.handleChange,
                onKeyPress: this.handleKeyPress,
                disabled: disableInput,
                'data-test': dataTest
              })
            )
          )
        ),
        hint && _react2.default.createElement(
          'div',
          { className: 'oc-select__hint' },
          hint
        ),
        errorMessage && _react2.default.createElement(
          'div',
          { className: 'oc-select__error' },
          errorMessage
        ),
        (!dropdown || openDropdown) && _react2.default.createElement(
          'div',
          { className: optionsContainerClassName },
          type === 'icons' ? _react2.default.createElement(
            'div',
            null,
            hideIcons ? _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                'div',
                { className: 'oc-select__expand-container', onClick: this.handleShowIcons },
                _react2.default.createElement(
                  'div',
                  { className: 'oc-select__expand-icon' },
                  showIcons ? '–' : '+'
                ),
                showIcons ? hideMessage : showMessage
              ),
              showIcons && _react2.default.createElement(_OnlyClickIconOptions2.default, {
                options: filteredOptions,
                selectedValues: values,
                onClick: this.handleClick,
                onTooltipEnter: onTooltipEnter,
                onTooltipOut: onTooltipOut,
                onHelpClick: onHelpIconClick,
                dataTest: dataTest
              })
            ) : _react2.default.createElement(_OnlyClickIconOptions2.default, {
              options: filteredOptions,
              selectedValues: values,
              onClick: this.handleClick,
              onTooltipEnter: onTooltipEnter,
              onTooltipOut: onTooltipOut,
              onHelpClick: onHelpIconClick,
              dataTest: dataTest
            })
          ) : _react2.default.createElement(_OnlyClickListOptions2.default, {
            options: filteredOptions,
            selectedValues: values,
            onClick: this.handleClick,
            typedValue: typedValue,
            highlight: highlight,
            highlightSanitizer: highlightSanitizer,
            withArrows: !noArrows,
            scrollable: scrollable
          })
        )
      );
    }
  }]);

  return OnlyClickSelect;
}(_react2.default.Component);

OnlyClickSelect.propTypes = {
  defaultValue: _propTypes2.default.string,
  type: _propTypes2.default.string,
  hint: _propTypes2.default.string,
  errorMessage: _propTypes2.default.string,
  placeholder: _propTypes2.default.string,
  options: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
  values: _propTypes2.default.arrayOf(_propTypes2.default.string),
  filterOption: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onClick: _propTypes2.default.func,
  onTooltipEnter: _propTypes2.default.func,
  onTooltipOut: _propTypes2.default.func,
  onDelete: _propTypes2.default.func,
  onHelpIconClick: _propTypes2.default.func,
  onEnterKeyPress: _propTypes2.default.func,
  disableFilter: _propTypes2.default.bool,
  disableDelete: _propTypes2.default.bool,
  autoFocus: _propTypes2.default.bool,
  highlight: _propTypes2.default.bool,
  highlightSanitizer: _propTypes2.default.func,
  disableInput: _propTypes2.default.bool,
  autoScroll: _propTypes2.default.bool,
  scrollTop: _propTypes2.default.number,
  maxVisible: _propTypes2.default.number,
  resetTypedValue: _propTypes2.default.bool,
  scrollable: _propTypes2.default.bool,
  dropdown: _propTypes2.default.bool,
  openedDropdown: _propTypes2.default.bool,
  smallInput: _propTypes2.default.bool,
  grayBorder: _propTypes2.default.bool,
  noArrows: _propTypes2.default.bool,
  hideInput: _propTypes2.default.bool,
  showOptionLabel: _propTypes2.default.bool,
  dataTest: _propTypes2.default.string,
  hideIcons: _propTypes2.default.bool,
  showMessage: _propTypes2.default.string,
  hideMessage: _propTypes2.default.string,
  onTrack: _propTypes2.default.func,
  trackName: _propTypes2.default.string,
  trackEvent: _propTypes2.default.object
};

OnlyClickSelect.defaultProps = {
  defaultValue: '',
  values: [],
  maxVisible: 1000,
  dataTest: ''
};

exports.default = OnlyClickSelect;