'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getQuestionIconClass = function getQuestionIconClass(props) {
  return (0, _classnames2.default)('question-icon', _defineProperty({}, 'question-icon--' + props.type, props.type));
};

function QuestionIcon(_ref) {
  var accordion = _ref.accordion,
      infoText = _ref.infoText,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, ['accordion', 'infoText', 'className']);

  return _react2.default.createElement(
    'div',
    _extends({ className: getQuestionIconClass(props) + ' ' + className }, props),
    !accordion && _react2.default.createElement(
      'span',
      { className: 'question-icon__tooltip-text' },
      infoText
    )
  );
}

QuestionIcon.propTypes = {
  accordion: _propTypes2.default.bool,
  type: _propTypes2.default.string,
  selected: _propTypes2.default.bool,
  children: _propTypes2.default.any,
  className: _propTypes2.default.string,
  infoText: _propTypes2.default.string
};

exports.default = QuestionIcon;