'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RadioInput = function RadioInput(props) {
  var id = props.id,
      name = props.name,
      label = props.label,
      className = props.className,
      labelClass = props.labelClass,
      value = props.value,
      onChange = props.onChange,
      checked = props.checked;

  var inputId = id || '' + name + value;
  var checkboxClassName = (0, _classnames2.default)('form-checkbox', className);

  var handleChange = function handleChange(e) {
    if (onChange) {
      onChange(e.target.value);
    }
  };
  return _react2.default.createElement(
    'div',
    { className: 'form-group form-group--checkbox' },
    _react2.default.createElement(
      'div',
      { className: checkboxClassName },
      _react2.default.createElement('input', {
        type: 'radio',
        id: inputId,
        name: name,
        onChange: handleChange,
        value: value,
        checked: checked
      }),
      _react2.default.createElement('label', { htmlFor: inputId })
    ),
    label && _react2.default.createElement(
      'label',
      { htmlFor: inputId, className: labelClass },
      label
    )
  );
};

RadioInput.propTypes = {
  id: _propTypes2.default.string,
  label: _propTypes2.default.string,
  name: _propTypes2.default.string.isRequired,
  className: _propTypes2.default.string,
  labelClass: _propTypes2.default.string,
  value: _propTypes2.default.any.isRequired,
  onChange: _propTypes2.default.func.isRequired,
  checked: _propTypes2.default.bool
};

exports.default = RadioInput;