'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _RadioInput = require('./RadioInput');

var _RadioInput2 = _interopRequireDefault(_RadioInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RadioInputGroup = function (_React$Component) {
  _inherits(RadioInputGroup, _React$Component);

  function RadioInputGroup(props) {
    _classCallCheck(this, RadioInputGroup);

    var _this = _possibleConstructorReturn(this, (RadioInputGroup.__proto__ || Object.getPrototypeOf(RadioInputGroup)).call(this, props));

    _this.handleChange = function (value) {
      _this.setState({ value: value });
      if (_this.props.onChange) {
        _this.props.onChange(value);
      }
    };

    _this.state = {
      value: props.value
    };
    return _this;
  }

  _createClass(RadioInputGroup, [{
    key: 'getValue',
    value: function getValue() {
      var value = this.state.value;
      if (this.props.getValue) {
        value = this.props.getValue();
      }
      return value;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          options = _props.options,
          name = _props.name,
          style = _props.style;

      var currentValue = this.getValue();
      var radioInputs = options.map(function (option, i) {
        return _react2.default.createElement(_RadioInput2.default, {
          key: i,
          label: option.label,
          name: name,
          value: option.value,
          checkedValue: _this2.getValue(),
          onChange: _this2.handleChange,
          checked: option.value === currentValue
        });
      });
      return _react2.default.createElement(
        'div',
        { className: 'box-radio-group', style: style },
        radioInputs
      );
    }
  }]);

  return RadioInputGroup;
}(_react2.default.Component);

RadioInputGroup.propTypes = {
  options: _propTypes2.default.arrayOf(_propTypes2.default.object),
  style: _propTypes2.default.object,
  name: _propTypes2.default.string,
  value: _propTypes2.default.any,
  onChange: _propTypes2.default.func,
  getValue: _propTypes2.default.func
};

exports.default = RadioInputGroup;