'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _uniq = require('lodash/uniq');

var _uniq2 = _interopRequireDefault(_uniq);

var _take = require('lodash/take');

var _take2 = _interopRequireDefault(_take);

var _OnlyClickListOptions = require('./OnlyClickListOptions');

var _OnlyClickListOptions2 = _interopRequireDefault(_OnlyClickListOptions);

var _stringHelper = require('../utils/string-helper');

var _stringHelper2 = _interopRequireDefault(_stringHelper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var filterOption = function filterOption(option, typedValue) {
  var text = typedValue.toLowerCase();
  var regexInput = new RegExp((0, _stringHelper2.default)(text));
  return regexInput.test(option.value.toLowerCase());
};

var SelectWithManualInput = function (_React$Component) {
  _inherits(SelectWithManualInput, _React$Component);

  function SelectWithManualInput() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SelectWithManualInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SelectWithManualInput.__proto__ || Object.getPrototypeOf(SelectWithManualInput)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      typedValue: '',
      isShowSelectOptions: false
    }, _this.getFilteredOptions = function (typedValue) {
      var _this$props = _this.props,
          options = _this$props.options,
          selectedOptions = _this$props.selectedOptions,
          maxVisible = _this$props.maxVisible;

      var availableOptions = options.filter(function (option) {
        return !selectedOptions.includes(option.value);
      });

      var filteredOptions = availableOptions.filter(function (option) {
        return filterOption(option, typedValue);
      });

      return (0, _take2.default)(filteredOptions, maxVisible);
    }, _this.setFocusOnInput = function () {
      _this.refs['text-input'].focus();
    }, _this.applyNotSelectionChange = function () {
      var typedValue = _this.state.typedValue;

      _this.setState({ isShowSelectOptions: false, typedValue: '' });

      if (!typedValue) return;
      var selectedOptions = _this.props.selectedOptions;

      _this.handleChange([].concat(_toConsumableArray(selectedOptions), [typedValue]));
    }, _this.handleChange = function (selectedOptions) {
      var onChange = _this.props.onChange;

      onChange((0, _uniq2.default)(selectedOptions));
    }, _this.handleInputTyping = function (e) {
      var typedValue = _this.state.typedValue;
      var value = e.target.value;


      _this.setState({ typedValue: value });
      if (typedValue !== value) {
        _this.setState({ isShowSelectOptions: true });
      }
    }, _this.handleFocus = function () {
      _this.setState({ isShowSelectOptions: true });
    }, _this.handleBlur = function () {
      setTimeout(_this.applyNotSelectionChange, 150);
    }, _this.handleSelectOption = function (optionSelected) {
      var selectedOptions = _this.props.selectedOptions;

      var newSelectedOptions = [];

      if (selectedOptions.includes(optionSelected)) {
        newSelectedOptions = selectedOptions.filter(function (option) {
          return option !== optionSelected;
        });
      } else {
        newSelectedOptions = [].concat(_toConsumableArray(selectedOptions), [optionSelected]);
      }
      _this.setState({ isShowSelectOptions: false, typedValue: '' });
      _this.handleChange(newSelectedOptions);
    }, _this.handleKeyPress = function (e) {
      if (e.key === 'Enter') {
        _this.applyNotSelectionChange();
      }
      if (e.key === 'Escape') {
        _this.setState({ isShowSelectOptions: false });
      }
    }, _this.handleDelete = function (optionToDelete) {
      var _this$props2 = _this.props,
          selectedOptions = _this$props2.selectedOptions,
          onDelete = _this$props2.onDelete;

      var updatedSelectedOptions = selectedOptions.filter(function (optionSelected) {
        return optionSelected !== optionToDelete;
      });

      _this.handleChange(updatedSelectedOptions);
      if (onDelete) {
        onDelete(optionToDelete);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SelectWithManualInput, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          options = _props.options,
          selectedOptions = _props.selectedOptions,
          highlight = _props.highlight,
          maxVisible = _props.maxVisible,
          animatedSelection = _props.animatedSelection;
      var _state = this.state,
          typedValue = _state.typedValue,
          isShowSelectOptions = _state.isShowSelectOptions;

      var filteredOptions = this.getFilteredOptions(typedValue);

      var isOptionsDisplayed = isShowSelectOptions && !!filteredOptions.length;

      return _react2.default.createElement(
        'div',
        { className: 'oc-select oc-select--hideable', ref: 'oc-select' },
        _react2.default.createElement(
          'div',
          { className: 'oc-select__search-container' },
          _react2.default.createElement(
            'div',
            { className: 'oc-select__search', ref: 'search-box', onClick: this.setFocusOnInput },
            selectedOptions.map(function (optionSelected) {
              return _react2.default.createElement(
                'span',
                { className: 'oc-selected-value', key: optionSelected },
                optionSelected,
                _react2.default.createElement('span', { className: 'oc-selected-value__close-icon', onClick: function onClick() {
                    return _this2.handleDelete(optionSelected);
                  } })
              );
            }),
            _react2.default.createElement(
              'div',
              { className: 'oc-select__input-container' },
              _react2.default.createElement('input', {
                ref: 'text-input',
                className: 'oc-select__input',
                type: 'text',
                value: typedValue,
                onChange: this.handleInputTyping,
                onKeyPress: this.handleKeyPress,
                onKeyDown: this.handleKeyPress,
                onFocus: this.handleFocus,
                onBlur: this.handleBlur
              })
            )
          )
        ),
        isOptionsDisplayed && _react2.default.createElement(
          'div',
          { className: 'oc-select__options-container' },
          _react2.default.createElement(_OnlyClickListOptions2.default, {
            options: filteredOptions,
            selectedValues: selectedOptions,
            onClick: this.handleSelectOption,
            typedValue: typedValue,
            highlight: highlight,
            animatedSelection: animatedSelection
          })
        )
      );
    }
  }]);

  return SelectWithManualInput;
}(_react2.default.Component);

SelectWithManualInput.propTypes = {
  options: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
  selectedOptions: _propTypes2.default.arrayOf(_propTypes2.default.string),
  onChange: _propTypes2.default.func,
  onClick: _propTypes2.default.func,
  onDelete: _propTypes2.default.func,
  onBlur: _propTypes2.default.func,
  highlight: _propTypes2.default.bool,
  maxVisible: _propTypes2.default.number,
  animatedSelection: _propTypes2.default.bool
};

SelectWithManualInput.defaultProps = {
  selectedOptions: [],
  maxVisible: 1000
};

exports.default = SelectWithManualInput;