'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _uniqueId = require('lodash/uniqueId');

var _uniqueId2 = _interopRequireDefault(_uniqueId);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Toggle = function (_Component) {
  _inherits(Toggle, _Component);

  function Toggle() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Toggle);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Toggle.__proto__ || Object.getPrototypeOf(Toggle)).call.apply(_ref, [this].concat(args))), _this), _this.handleClick = function (e) {
      var onToggle = _this.props.onToggle;


      if (onToggle) {
        onToggle(e);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Toggle, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          disabled = _props.disabled,
          id = _props.id,
          label = _props.label,
          dataTest = _props.dataTest;

      var inputId = id || 'toggle-' + (0, _uniqueId2.default)();

      return _react2.default.createElement(
        'div',
        { className: 'cw-toggle' },
        _react2.default.createElement(
          'label',
          { className: 'cw-toggle__switch', 'data-test': dataTest },
          _react2.default.createElement('input', {
            id: inputId,
            className: 'cw-toggle__input',
            type: 'checkbox',
            checked: value,
            onChange: this.handleClick,
            disabled: disabled
          }),
          _react2.default.createElement('span', { className: 'cw-toggle__slider cw-toggle__slider--round' })
        ),
        label && _react2.default.createElement(
          'label',
          { htmlFor: inputId, className: 'cw-toggle__label' },
          label
        )
      );
    }
  }]);

  return Toggle;
}(_react.Component);

Toggle.propTypes = {
  id: _propTypes2.default.string,
  label: _propTypes2.default.string,
  value: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  onToggle: _propTypes2.default.func,
  dataTest: _propTypes2.default.string
};

exports.default = Toggle;