'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _uniqueId = require('lodash/uniqueId');

var _uniqueId2 = _interopRequireDefault(_uniqueId);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Tooltip = require('./Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function TooltipIcon(props) {
  var id = props.id,
      containerClassName = props.containerClassName,
      iconClassName = props.iconClassName,
      tooltipClassName = props.tooltipClassName,
      text = props.text,
      children = props.children,
      position = props.position;

  var iconId = id || (0, _uniqueId2.default)('tooltip-icon-');
  var iconClass = (0, _classnames2.default)('help-icon', iconClassName);

  return _react2.default.createElement(
    'span',
    { className: containerClassName },
    _react2.default.createElement('span', { className: iconClass, id: iconId, tabIndex: '-1' }),
    _react2.default.createElement(
      _Tooltip2.default,
      { 'for': iconId, className: tooltipClassName, text: text, position: position },
      children
    )
  );
}

TooltipIcon.propTypes = {
  id: _propTypes2.default.string,
  containerClassName: _propTypes2.default.string,
  iconClassName: _propTypes2.default.string,
  tooltipClassName: _propTypes2.default.string,
  text: _propTypes2.default.string,
  children: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.node), _propTypes2.default.node]),
  position: _propTypes2.default.string
};

exports.default = TooltipIcon;