'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var addModifierClass = function addModifierClass(modifier, modValue) {
  return function (classname) {
    return (0, _classnames2.default)(classname, _defineProperty({}, classname + '--' + modifier, modValue));
  };
};

var WideButton = function WideButton(_ref) {
  var selected = _ref.selected,
      children = _ref.children,
      dataTest = _ref.dataTest;

  var addClassWithSelected = addModifierClass('selected', selected);

  return _react2.default.createElement(
    'li',
    { className: addClassWithSelected('wide-button'), 'data-test': dataTest },
    _react2.default.createElement(
      'div',
      { className: 'wide-button__title--space-between wide-button__title' },
      children
    )
  );
};

WideButton.propTypes = {
  selected: _propTypes2.default.bool,
  children: _propTypes2.default.any,
  dataTest: _propTypes2.default.string
};

exports.default = WideButton;